=== debian/changelog ===
boinc (7.24.1+dfsg-4build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:44:28 +0000

boinc (7.24.1+dfsg-4) unstable; urgency=medium

  * Add patch to fix time64 misbuilds on armhf

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 18 Mar 2024 09:18:19 +0100

boinc (7.24.1+dfsg-3) unstable; urgency=medium

  * Upload to sid.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 28 Feb 2024 12:04:05 +0100

boinc (7.24.1+dfsg-2exp2) experimental; urgency=medium

  [ Steve Langasek ]
  * Patch debian/control.in, which uses idiosyncratic format and therefore
    failed to be automatically patched, then clobbered necessary changes in
    debian/control regarding Breaks/Replaces/Provides.  Closes: #1061984.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 24 Feb 2024 09:03:04 +0100

boinc (7.24.1+dfsg-2exp1) experimental; urgency=medium

  [ Steve Langasek ]
  * Patch debian/control.in, which uses idiosyncratic format and therefore
    failed to be automatically patched, then clobbered necessary changes in
    debian/control regarding Breaks/Replaces/Provides.  Closes: #1061984.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 20 Feb 2024 14:24:45 +0100

boinc (7.24.1+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061934

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 03:42:25 +0000

boinc (7.24.1+dfsg-2) unstable; urgency=medium

  * Ack previous NMU, thanks!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 20 Feb 2024 14:22:19 +0100

boinc (7.24.1+dfsg-1) unstable; urgency=medium

  * New upstream version 7.24.1+dfsg
  * Bump copyright years
  * Refresh patches
  * Drop switcher, removed upstream

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 20 Feb 2024 09:37:05 +0100

boinc (7.20.5+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Ship systemd unit under /lib/systemd/system so that it can get picked
    up by dh_installsystemd (Closes: #1034216)

 -- Cyril Brulebois <kibi@debian.org>  Tue, 25 Apr 2023 16:59:54 +0000
