## boinc 8.0.2+dfsg

=== debian/changelog ===
boinc (8.0.2+dfsg-1) unstable; urgency=medium

  * fix watch file
  * New upstream version 8.0.2+dfsg
  * Refresh patches
  * Add some new samples
  * Bump copyright years

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 May 2024 23:55:00 +0200
